C     **************************                                              
C     * PDE2D 9.2 MAIN PROGRAM *                                              
C     **************************                                              
C     *** 2D PROBLEM SOLVED (GALERKIN METHOD) ***                             
C##############################################################################
C     Is double precision mode to be used?  Double precision is recommended   #
C     on 32-bit computers.                                                    #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If double precision mode is used, variables and functions assigned   +#
C     + names beginning with a letter in the range A-H or O-Z will be DOUBLE +#
C     + PRECISION, and you should use double precision constants and FORTRAN +#
C     + expressions throughout; otherwise such variables and functions will  +#
C     + be of type REAL.  In either case, variables and functions assigned   +#
C     + names beginning with I,J,K,L,M or N will be of INTEGER type.         +#
C     +                                                                      +#
C     + It is possible to convert a single precision PDE2D program to double +#
C     + precision after it has been created, using an editor.  Just change   +#
C     + all occurrences of "real" to "double precision"                      +#
C     +                    " tdp" to "dtdp"  (note leading blank)            +#
C     + Any user-written code or routines must be converted "by hand", of    +#
C     + course.  To convert from double to single, reverse the changes.      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      implicit double precision (a-h,o-z)
      parameter (neqnmx=  99)
      parameter (ndelmx=  20)
      parameter (nxgrid=0,nygrid=0,npgrid=0,nqgrid=0)
C##############################################################################
C     NV0 = number of vertices in initial triangulation                       #
C##############################################################################
      PARAMETER (NV0 = 7)             
C##############################################################################
C     NT0 = number of triangles in initial triangulation                      #
C##############################################################################
      PARAMETER (NT0 = 7)             
C##############################################################################
C     How many differential equations (NEQN) are there in your problem?       #
C##############################################################################
      PARAMETER (NEQN = 1)            
C        DIMENSIONS OF WORK ARRAYS                                            
C        SET TO 1 FOR AUTOMATIC ALLOCATION                                    
      PARAMETER (IRWK8Z=           1)
      PARAMETER (IIWK8Z=           1)
      PARAMETER (NXP8Z=101,NYP8Z=101,KDEG8Z=1,NBPT8Z=51)
C##############################################################################
C     The solution is normally saved on a NX+1 by NY+1 rectangular grid of    #
C     points                                                                  #
C                   (XA + I*(XB-XA)/NX , YA + J*(YB-YA)/NY)                   #
C     I=0,...,NX, J=0,...,NY.  Enter values for NX and NY.  Suggested values  #
C     are NX=NY=25.                                                           #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you want to save the solution at an arbitrary user-specified      +#
C     + set of points, set NY=0 and NX+1=number of points.  In this case you +#
C     + can request tabular output of the solution, but you cannot make any  +#
C     + solution plots.                                                      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      PARAMETER (NX = 100)             
      PARAMETER (NY =  50)             
      PARAMETER (NSAVE = 1)
      common/parm8z/ pi,D1    ,D2    
      dimension vxy(2,nv0+1),iabc(3,nt0+1),iarc(nt0+1),xgrid(nxgrid+1),y       
     &grid(nygrid+1),ixarc(2),iyarc(2),pgrid(npgrid+1),qgrid(nqgrid+1),i       
     &parc(2),iqarc(2),xbd8z(nbpt8z,nt0+4),ybd8z(nbpt8z,nt0+4),xout8z(0:       
     &nx,0:ny),yout8z(0:nx,0:ny),inrg8z(0:nx,0:ny),xcross(100),ycross(10       
     &0),tout8z(0:nsave),uout8z(0:nx,0:ny,3*neqn,0:nsave),uout(0:nx,0:ny       
     &,3,neqn,0:nsave),xres8z(nxp8z),yres8z(nyp8z),ures8z(neqn,nxp8z,nyp       
     &8z),xd0(ndelmx),yd0(ndelmx)                                              
      equivalence (uout,uout8z)                                                
      allocatable iwrk8z(:),rwrk8z(:)                                          
C      dimension iwrk8z(iiwk8z),rwrk8z(irwk8z)                                 
      character*40 title                                                       
      logical plot,symm,fdiff,evcmpx,crankn,noupdt,adapt,nodist,fillin,e       
     &con8z,ncon8z,restrt,gridid                                               
      common/dtdp14/ sint8z(20),bint8z(20),slim8z(20),blim8z(20)               
      common/dtdp15/ evlr8z,ev0r,evli8z,ev0i,evcmpx                            
      common/dtdp16/ p8z,evr8z(50),evi8z(50)                                   
      common/dtdp19/ toler(neqnmx),adapt                                       
      common/dtdp22/ nxa8z,nya8z,ifgr8z,kd8z,nbp8z                             
      common/dtdp23/ work8z(nxp8z*nyp8z+6)                                     
      common/dtdp30/ econ8z,ncon8z                                             
      common/dtdp46/ eps8z,cgtl8z,npmx8z,itype                                 
      common/dtdp63/ amin8z(3*neqnmx),amax8z(3*neqnmx)                         
      common/dtdp65/ intri,iotri                                               
      pi = 4.0*atan(1.d0)                                                      
      nxa8z = nxp8z                                                            
      nya8z = nyp8z                                                            
      kd8z = kdeg8z                                                            
      nbp8z = nbpt8z                                                           
C##############################################################################
C     If you don't want to read the FINE PRINT, default NPROB.                #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you want to solve several similar problems in the same run, set   +#
C     + NPROB equal to the number of problems you want to solve.  Then NPROB +#
C     + loops through the main program will be done, with IPROB=1,...,NPROB, +#
C     + and you can make the problem parameters vary with IPROB.  NPROB      +#
C     + defaults to 1.                                                       +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NPROB = 1                                                                
      do 78755 iprob=1,nprob                                                   
C##############################################################################
C     You may now define global parameters, which may be referenced in any    #
C     of the "FORTRAN expressions" you input throughout the rest of this      #
C     interactive session.  You will be prompted alternately for parameter    #
C     names and their values; enter a blank name when you are finished.       #
C                                                                             #
C     Parameter names are valid FORTRAN variable names, starting in           #
C     column 1.  Thus each name consists of 1 to 6 alphanumeric characters,   #
C     the first of which must be a letter.  If the first letter is in the     #
C     range I-N, the parameter must be an integer.                            #
C                                                                             #
C     Parameter values are either FORTRAN constants or FORTRAN expressions    #
C     involving only constants and global parameters defined on earlier       #
C     lines.  They may also be functions of the problem number IPROB, if      #
C     you are solving several similar problems in one run (NPROB > 1).  Note  #
C     that you are defining global CONSTANTS, not functions; e.g., parameter  #
C     values may not reference any of the independent or dependent variables  #
C     of your problem.                                                        #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you define other parameters here later, using an editor, you must +#
C     + add them to COMMON block /PARM8Z/ everywhere this block appears, if  +#
C     + they are to be "global" parameters.                                  +#
C     +                                                                      +#
C     + The variable PI is already included as a global parameter, with an   +#
C     + accurate value 3.14159...                                            +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      D1     =                                                                 
     & 5                                                                       
      D2     =                                                                 
     & 5                                                                       
C        *******INITIAL TRIANGULATION OPTION                                   
      INTRI =          3                                                       
C        *******SET IOTRI = 1 TO DUMP FINAL TRIANGULATION TO FILE pde2d.tri    
      IOTRI = 0                                                                
C##############################################################################
C     For a general region, an initial triangulation is constructed           #
C     which generally consists of only as many triangles as needed to define  #
C     the region and to satisfy the following rules (triangles adjacent       #
C     to a curved boundary may be considered to have one curved edge):        #
C                                                                             #
C     1. The end points of each arc are included as vertices in the           #
C        triangulation.                                                       #
C                                                                             #
C     2. No vertex of any triangle may touch another in a point which is      #
C        not a vertex of the other triangle.                                  #
C                                                                             #
C     3. No triangle may have all three vertices on the boundary.             #
C                                                                             #
C     Now enter the number of vertices in the initial triangulation (NV0)     #
C     and the vertices (VXY(1,i),VXY(2,i)), i=1,...,NV0, when prompted.       #
C                                                                             #
C     The vertices may be numbered in any order, but that order will define   #
C     the vertex numbers referred to in the next list.                        #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If the elements of VXY, IABC and IARC are defaulted, these initial   +#
C     + triangulation arrays will be read from the file 'pde2d.tri'; in this +#
C     + case the values of NV0 and NT0 entered below must be the same as     +#
C     + those in the file.                                                   +#
C     +                                                                      +#
C     + A file 'pde2d.tri' is normally created when the final triangulation  +#
C     + from another program (cases INTRI=1,2 or 3) is dumped.  Reset IOTRI  +#
C     + to 1 in the other program, to cause the final triangulation to be    +#
C     + dumped into pde2d.tri.                                               +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      call dtdpwx(vxy,2*nv0,0)                                                 
C                                                                              
      VXY(1,1) =                                                               
     & -1                                                                      
      VXY(2,1) =                                                               
     & 0                                                                       
C                                                                              
      VXY(1,2) =                                                               
     & 0                                                                       
      VXY(2,2) =                                                               
     & 0                                                                       
C                                                                              
      VXY(1,3) =                                                               
     & 1                                                                       
      VXY(2,3) =                                                               
     & 0                                                                       
C                                                                              
      VXY(1,4) =                                                               
     & 0                                                                       
      VXY(2,4) =                                                               
     & 1                                                                       
C                                                                              
      VXY(1,5) =                                                               
     & -1                                                                      
      VXY(2,5) =                                                               
     & 1                                                                       
C                                                                              
      VXY(1,6) =                                                               
     & -0.5                                                                    
      VXY(2,6) =                                                               
     & 0.5                                                                     
C                                                                              
      VXY(1,7) =                                                               
     & 0.2                                                                     
      VXY(2,7) =                                                               
     & 0.4                                                                     
C##############################################################################
C     Now enter the number of triangles in the initial triangulation (NT0),   #
C     and for each triangle k, give the vertex numbers of vertices a,b,c:     #
C                 IABC(1,k) , IABC(2,k) , IABC(3,k)                           #
C     where the third vertex (c) is not on the boundary of R (or on a curved  #
C     interface arc), and the number,                                         #
C                             IARC(k)                                         #
C     of the arc cut off by the base, ab, of the triangle.  Put IARC(k)=0     #
C     if the base of triangle k does not intersect any boundary (or curved    #
C     interface) arc.  Recall that negative arc numbers correspond to         #
C     'fixed' boundary conditions, and positive arc numbers ( < 1000)         #
C     correspond to 'free' boundary conditions.                               #
C                                                                             #
C     The order of this list defines the initial triangle numbers.            #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Any of the partial differential equation coefficients or other       +#
C     + functions of X and Y which you are asked to supply later may be      +#
C     + defined as functions of a variable 'KTRI', which holds the number    +#
C     + of the INITIAL triangle in which (X,Y) lies.  This is useful when    +#
C     + the region is a composite of different materials, so that some       +#
C     + material parameters have different values in different subregions.   +#
C     ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++#
C     + If any interfaces between subregions are curved, the interface arcs  +#
C     + may be assigned unique arc numbers of 1000 and above, and treated    +#
C     + like boundary arcs in the initial triangulation definition.  (You    +#
C     + will not be allowed to specify boundary conditions on them, however.)+#
C     + The triangulation refinement will follow the interface arcs, so that +#
C     + no final triangles will straddle an interface.                       +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C                                                                              
      IABC(1,1) =                                                              
     & 1                                                                       
      IABC(2,1) =                                                              
     & 2                                                                       
      IABC(3,1) =                                                              
     & 6                                                                       
      IARC(1) =                                                                
     & 1                                                                       
C                                                                              
      IABC(1,2) =                                                              
     & 2                                                                       
      IABC(2,2) =                                                              
     & 4                                                                       
      IABC(3,2) =                                                              
     & 6                                                                       
      IARC(2) =                                                                
     & 0                                                                       
C                                                                              
      IABC(1,3) =                                                              
     & 4                                                                       
      IABC(2,3) =                                                              
     & 5                                                                       
      IABC(3,3) =                                                              
     & 6                                                                       
      IARC(3) =                                                                
     & 2                                                                       
C                                                                              
      IABC(1,4) =                                                              
     & 5                                                                       
      IABC(2,4) =                                                              
     & 1                                                                       
      IABC(3,4) =                                                              
     & 6                                                                       
      IARC(4) =                                                                
     & -1                                                                      
C                                                                              
      IABC(1,5) =                                                              
     & 2                                                                       
      IABC(2,5) =                                                              
     & 3                                                                       
      IABC(3,5) =                                                              
     & 7                                                                       
      IARC(5) =                                                                
     & 1                                                                       
C                                                                              
      IABC(1,6) =                                                              
     & 3                                                                       
      IABC(2,6) =                                                              
     & 4                                                                       
      IABC(3,6) =                                                              
     & 7                                                                       
      IARC(6) =                                                                
     & 3                                                                       
C                                                                              
      IABC(1,7) =                                                              
     & 4                                                                       
      IABC(2,7) =                                                              
     & 2                                                                       
      IABC(3,7) =                                                              
     & 7                                                                       
      IARC(7) =                                                                
     & 0                                                                       
      call dtdpu(vxy,nv0,iabc,iarc,nt0)                                        
C##############################################################################
C     How many triangles (NTF) are desired for the final triangulation?       #
C##############################################################################
      NTF =       2000                                                         
C##############################################################################
C     If you don't want to read the FINE PRINT, enter ISOLVE = 4.             #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + The following linear system solvers are available:                   +#
C     +                                                                      +#
C     + 1. Band method                                                       +#
C     +               The band solver uses a reverse Cuthill-McKee ordering. +#
C     + 2. Frontal method                                                    +#
C     +               This is an out-of-core version of the band solver.     +#
C     + 3. Jacobi bi-conjugate gradient method                               +#
C     +               This is a preconditioned bi-conjugate gradient, or     +#
C     +               Lanczos, iterative method.  (This solver is MPI-       +#
C     +               enhanced, if MPI is available.)  If you want to        +#
C     +               override the default convergence tolerance, set a      +#
C     +               new relative tolerance CGTL8Z in the main program.     +#
C     + 4. Sparse direct method                                              +#
C     +               This is based on Harwell Library routines MA27/MA37,   +#
C     +               developed by AEA Industrial Technology at Harwell      +#
C     +               Laboratory, Oxfordshire, OX11 0RA, United Kingdom      +#
C     +               (used by permission).                                  +#
C     + 5. Local solver                                                      +#
C     +               Choose this option ONLY if alternative linear system   +#
C     +               solvers have been installed locally.  See subroutines  +#
C     +               (D)TD3M, (D)TD3N in file (d)subs.f for instructions    +#
C     +               on how to add local solvers.                           +#
C     + 6. MPI-based parallel band solver                                    +#
C     +               This is a parallel solver which runs efficiently on    +#
C     +               multiple processor machines, under MPI.  It is a       +#
C     +               band solver, with the matrix distributed over the      +#
C     +               available processors.  Choose this option ONLY if the  +#
C     +               solver has been activated locally.  See subroutine     +#
C     +               (D)TD3O in file (d)subs.f for instructions on how to   +#
C     +               activate this solver and the MPI-enhancements to the   +#
C     +               conjugate gradient solver.                             +#
C     +                                                                      +#
C     + Enter ISOLVE = 1,2,3,4,5 or 6 to select a linear system solver.      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      ISOLVE =          4                                                      
C##############################################################################
C     Enter the element degree (1,2,3 or 4) desired.  A suggested value is    #
C     IDEG = 3.                                                               #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + A negative value for IDEG can be entered, and elements of degree     +#
C     + ABS(IDEG) will be used, with a lower order numerical integration     +#
C     + scheme.  This results in a slight increase in speed, but negative    +#
C     + values of IDEG are normally not recommended.  However, IDEG = -1     +#
C     + is the only choice which will produce a lumped (diagonal) mass       +#
C     + matrix.                                                              +#
C     +                                                                      +#
C     + The spatial discretization error is O(h**2), O(h**3), O(h**4) or     +#
C     + O(h**5) when elements of degree 1,2,3 or 4, respectively, are used,  +#
C     + where h is the maximum triangle diameter, even if the region is      +#
C     + curved.                                                              +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      IDEG =          3                                                        
C        *******STEADY-STATE PROBLEM                                           
      itype = 1                                                                
      t0 = 0.0                                                                 
      dt = 1.0                                                                 
      crankn = .false.                                                         
      noupdt = .false.                                                         
C        Number of Newton iterations                                           
      NSTEPS = 1                                                               
C##############################################################################
C     PDE2D solves the equation:                                              #
C                                                                             #
C                      d/dX* A(X,Y,C,Cx,Cy)                                   #
C                    + d/dY* B(X,Y,C,Cx,Cy)                                   #
C                          = F(X,Y,C,Cx,Cy)                                   #
C                                                                             #
C     with 'fixed' boundary condition:                                        #
C                                                                             #
C           C = FB(X,Y)                                                       #
C                                                                             #
C     or 'free' boundary condition:                                           #
C                                                                             #
C           A*nx + B*ny = GB(X,Y,C,Cx,Cy)                                     #
C                                                                             #
C     where C(X,Y) is the unknown and F,A,B,FB,GB are user-supplied           #
C     functions.                                                              #
C                                                                             #
C     note:                                                                   #
C           (nx,ny) = unit outward normal to the boundary                     #
C           Cx = d(C)/dX                                                      #
C           Cy = d(C)/dY                                                      #
C                                                                             #
C     Is this problem symmetric?  If you don't want to read the FINE PRINT,   #
C     it is safe to enter 'no'.                                               #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + This problem is called symmetric if the matrix                       +#
C     +                                                                      +#
C     +                F.C     F.Cx     F.Cy                                 +#
C     +                A.C     A.Cx     A.Cy                                 +#
C     +                B.C     B.Cx     B.Cy                                 +#
C     +                                                                      +#
C     + is always symmetric, where F.C means d(F)/d(C), and similarly        +#
C     + for the other terms.  In addition, GB must not depend on Cx,Cy.      +#
C     +                                                                      +#
C     + The memory and execution time are halved if the problem is known to  +#
C     + be symmetric.                                                        +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      SYMM = .TRUE.                                                            
      FDIFF = .FALSE.                                                          
C##############################################################################
C     You may calculate one or more integrals (over the entire region) of     #
C     some functions of the solution and its derivatives.  How many integrals #
C     (NINT), if any, do you want to calculate?                               #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + In the FORTRAN program created by the preprocessor, the computed     +#
C     + values of the integrals will be returned in the vector SINT8Z.  If   +#
C     + several iterations or time steps are done, only the last computed    +#
C     + values are saved in SINT8Z (all values are printed).                 +#
C     +                                                                      +#
C     + A limiting value, SLIM8Z(I), for the I-th integral can be set        +#
C     + below in the main program.  The computations will then stop          +#
C     + gracefully whenever SINT8Z(I) > SLIM8Z(I), for any I=1...NINT.       +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NINT =          1                                                        
C##############################################################################
C     You may calculate one or more boundary integrals (over the entire       #
C     boundary) of some functions of the solution and its derivatives.  How   #
C     many boundary integrals (NBINT), if any, do you want to calculate?      #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + In the FORTRAN program created by the preprocessor, the computed     +#
C     + values of the integrals will be returned in the vector BINT8Z.  If   +#
C     + several iterations or time steps are done, only the last computed    +#
C     + values are saved in BINT8Z (all values are printed).                 +#
C     +                                                                      +#
C     + A limiting value, BLIM8Z(I), for the I-th boundary integral can be   +#
C     + set below in the main program.  The computations will then stop      +#
C     + gracefully whenever BINT8Z(I) > BLIM8Z(I), for any I=1...NBINT.      +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NBINT =          1                                                       
      ndel = 0                                                                 
      RESTRT = .FALSE.                                                         
      GRIDID = .TRUE.                                                          
C##############################################################################
C     The solution is saved on an NX+1 by NY+1 rectangular grid covering the  #
C     rectangle (XA,XB) x (YA,YB).  Enter values for XA,XB,YA,YB.  These      #
C     variables are usually defaulted.                                        #
C                                                                             #
C     The default is a rectangle which just covers the entire region.         #
C##############################################################################
C        defaults for xa,xb,ya,yb                                              
      call dtdpv   (xgrid,nxgrid,ygrid,nygrid,vxy,nv0,iarc,nt0,xa,xb,ya,       
     &yb)                                                                      
C        DEFINE XA,XB,YA,YB HERE:                                              
      call dtdpx2(nx,ny,xa,xb,ya,yb,hx8z,hy8z,xout8z,yout8z,npts8z)            
C        SOLUTION SAVED EVERY NOUT ITERATIONS                                  
      NOUT = NSTEPS                                                            
C        *******allocate workspace                                             
      call dtdpzz(ntf,ideg,isolve,symm,neqn,ii8z,ir8z)                         
      if (iiwk8z.gt.1) ii8z = iiwk8z                                           
      if (irwk8z.gt.1) ir8z = irwk8z                                           
      allocate (iwrk8z(ii8z),rwrk8z(ir8z))                                     
C        *******DRAW TRIANGULATION PLOTS (OVER                                 
C        *******RECTANGLE (XA,XB) x (YA,YB))?                                  
      PLOT = .TRUE.                                                            
C        *******call pde solver                                                
      call dtdp2x(xgrid, nxgrid, ygrid, nygrid, ixarc, iyarc, vxy, nv0,        
     &iabc, nt0, iarc, restrt, gridid, neqn, ntf, ideg, isolve, nsteps,        
     &nout, t0, dt, plot, symm, fdiff, itype, nint, nbint, ndel, xd0, yd       
     &0, crankn, noupdt, xbd8z, ybd8z, nbd8z, xout8z, yout8z, uout, inrg       
     &8z, npts8z, ny, tout8z, nsave, iwrk8z, ii8z, rwrk8z, ir8z)               
      deallocate (iwrk8z,rwrk8z)                                               
C        *******read from restart file to array ures8z                         
C      call dtdpr2(1,xres8z,nxp8z,yres8z,nyp8z,ures8z,neqn)                    
C        *******write array ures8z back to restart file                        
C      call dtdpr2(2,xres8z,nxp8z,yres8z,nyp8z,ures8z,neqn)                    
C        *******call user-written postprocessor                                
      call postpr(tout8z,nsave,xout8z,yout8z,inrg8z,nx,ny,uout,neqn)           
C        *******CONTOUR PLOT                                                   
C##############################################################################
C     Enter a value for IVAR, to select the variable to be plotted or         #
C     printed:                                                                #
C         IVAR = 1 means C  (possibly as modified by UPRINT,..)               #
C                2       A                                                    #
C                3       B                                                    #
C##############################################################################
      IVAR =          1                                                        
      ISET1 = 1                                                                
      ISET2 = NSAVE                                                            
      ISINC = 1                                                                
C##############################################################################
C     If you don't want to read the FINE PRINT, enter 'no'.                   #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Do you want to scale the axes on the plot so that the region is      +#
C     + undistorted?  Otherwise the axes will be scaled so that the figure   +#
C     + approximately fills the plot space.                                  +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      NODIST = .TRUE.                                                          
C                                                                              
      alow = amin8z(ivar)                                                      
      ahigh = amax8z(ivar)                                                     
C##############################################################################
C     Enter lower (UMIN) and upper (UMAX) bounds for the contour values. UMIN #
C     and UMAX are often defaulted.                                           #
C                                                                             #
C     Labeled contours will be drawn corresponding to the values              #
C                                                                             #
C                  UMIN + S*(UMAX-UMIN),    for S=0.05,0.15,...0.95.          #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + By default, UMIN and UMAX are set to the minimum and maximum values  +#
C     + of the variable to be plotted.  For a common scaling, you may want   +#
C     + to set UMIN=ALOW, UMAX=AHIGH.  ALOW and AHIGH are the minimum and    +#
C     + maximum values over all output points and over all saved time steps  +#
C     + or iterations.                                                       +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      UMIN = 0.0                                                               
      UMAX = 0.0                                                               
C##############################################################################
C     Do you want two additional unlabeled contours to be drawn between each  #
C     pair of labeled contours?                                               #
C##############################################################################
      FILLIN = .FALSE.                                                         
C##############################################################################
C     Enter a title, WITHOUT quotation marks.  A maximum of 40 characters     #
C     are allowed.  The default is no title.                                  #
C##############################################################################
      TITLE = ' '                                                              
      TITLE = 'C                                       '                       
      call dtdprx(tout8z,nsave,iset1,iset2,isinc)                              
      do 78756 is8z=iset1,iset2,isinc                                          
      call dtdplg(uout8z(0,0,ivar,is8z),nx,ny,xa,ya,hx8z,hy8z,inrg8z,xbd       
     &8z,ybd8z,nbd8z,title,umin,umax,nodist,fillin,tout8z(is8z))               
78756 continue                                                                 
78755 continue                                                                 
      call endgks                                                              
      stop                                                                     
      end                                                                      
                                                                               
                                                                               
      subroutine tran8z(p,q,x,y)                                               
      implicit double precision (a-h,o-z)                                      
      x = p                                                                    
      y = q                                                                    
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine xy8z(i8z,iarc8z,s,x,y,s0,sf)                                  
      implicit double precision (a-h,o-z)                                      
      dimension pxy(2,1000)                                                    
      common/parm8z/ pi,D1    ,D2                                              
      x = 0.0                                                                  
      y = 0.0                                                                  
C##############################################################################
C     Enter the arc number (IARC) of a curved arc.                            #
C##############################################################################
      IARC =          3                                                        
                if (iarc8z.eq.iarc) then                                       
C##############################################################################
C     The arc is parameterized as X=X(S),Y=Y(S) where S varies from S0 to SF  #
C     as it traces out the arc, in either direction.                          #
C                                                                             #
C     Enter FORTRAN expressions for S0, SF, X(S) and Y(S).  S0 and SF default #
C     to 0 and 1.                                                             #
C##############################################################################
           if (i8z.eq.0) then                                                  
      S0 =                                                                     
     & 0                                                                       
      SF =                                                                     
     & 1                                                                       
           else                                                                
      X =                                                                      
     & s                                                                       
      Y =                                                                      
     & cos(pi/2*s)                                                             
           endif                                                               
                endif                                                          
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine dis8z(x,y,ktri,triden,shape)                                  
      implicit double precision (a-h,o-z)                                      
      common/parm8z/ pi,D1    ,D2                                              
      adapt = dtdplx(2)                                                        
C##############################################################################
C     Now enter a FORTRAN expression for TRIDEN(X,Y), which controls the      #
C     grading of the triangulation.  TRIDEN should be largest where the       #
C     triangulation is to be most dense.  The default is TRIDEN(X,Y)=1.0      #
C     (a uniform triangulation).                                              #
C                                                                             #
C     If you want the triangulation to be graded "adaptively", set            #
C     TRIDEN = ADAPT and and make sure there is no "pde2d.adp" file in the    #
C     working directory the first time you run the program, then run the      #
C     program 2 or more times, possibly increasing NTF each time.  On the     #
C     first run, a uniform triangulation will be generated, but on each       #
C     subsequent run, information output by the previous run to "pde2d.adp"   #
C     will be used to guide the grading of the new triangulation.             #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If TRIDEN = ADAPT, after each run a file "pde2d.adp" is written      +#
C     + which tabulates the values of the magnitude of the gradient of the   +#
C     + solution (at the last time step or iteration) at an output NXP8Z by  +#
C     + NYP8Z grid of points (NXP8Z and NYP8Z are set to 101 in a PARAMETER  +#
C     + statement in the main program, so they can be changed if desired).   +#
C     + If NEQN > 1, a normalized average of the gradients of the NEQN       +#
C     + solution components is used.                                         +#
C     +                                                                      +#
C     + You can do all the "runs" in one program, by setting NPROB > 1.      +#
C     + Each pass through the DO loop, PDE2D will read the gradient values   +#
C     + output the previous pass.                                            +#
C     +                                                                      +#
C     + TRIDEN may also be a function of the initial triangle number KTRI.   +#
C     +                                                                      +#
C     + Increase the variable EXAG from its default value of 1.5 if you want +#
C     + to exaggerate the grading of an adaptive triangulation (make it less +#
C     + uniform).  EXAG should normally not be larger than about 2.0.        +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      TRIDEN = 1.0                                                             
      EXAG = 1.5                                                               
C##############################################################################
C     If you don't want to read the FINE PRINT, default SHAPE.                #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Enter a FORTRAN expression for SHAPE(X,Y), which controls the        +#
C     + approximate shape of the triangles.  The triangulation refinement    +#
C     + will proceed with the goal of generating triangles with an average   +#
C     + height to width ratio of approximately SHAPE(X,Y) near the point     +#
C     + (X,Y).  SHAPE must be positive.  The default is SHAPE(X,Y)=1.0.      +#
C     +                                                                      +#
C     + SHAPE may also be a function of the initial triangle number KTRI.    +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
      SHAPE = 1.0                                                              
      if (triden.eq.adapt) triden = dtdpgr(x,y)**exag                          
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine pdes8z(yd8z,i8z,j8z,kint8z,idel8z,jdel8z,x,y,ktri,t)          
      implicit double precision (a-h,o-z)                                      
      parameter (neqnmx=  99)                                                  
      parameter (ndelmx=  20)                                                  
C        un8z(1,I),un8z(2,I),un8z(3,I) hold the (rarely used) values           
C        of UI,UIx,UIy from the previous iteration or time step                
      common/dtdp4/un8z(3,neqnmx),uu8z(3,neqnmx)                               
      common/dtdp17/normx,normy,iarc                                           
      double precision normx,normy,delamp(ndelmx,neqnmx)                       
      common/parm8z/ pi,D1    ,D2                                              
      C  = uu8z(1, 1)                                                          
      Cx = uu8z(2, 1)                                                          
      Cy = uu8z(3, 1)                                                          
      Cnorm = Cx*normx + Cy*normy                                              
                          if (i8z.eq.0) then                                   
      yd8z = 0.0                                                               
C##############################################################################
C     Enter FORTRAN expressions for the functions whose integrals are to be   #
C     calculated and printed.  They may be functions of                       #
C                                                                             #
C                X,Y,C,Cx,Cy and (if applicable) T                            #
C                                                                             #
C     The integrals may also contain references to the initial triangle       #
C     number KTRI.                                                            #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + If you only want to integrate a function over part of the region,    +#
C     + define that function to be zero in the rest of the region.           +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C                                                  INTEGRAL DEFINED            
      if (kint8z.eq.    1) yd8z =                                              
     & 2*pi*y*C                                                                
C##############################################################################
C     Enter FORTRAN expressions for the functions whose integrals are to be   #
C     calculated and printed.  They may be functions of                       #
C                                                                             #
C                X,Y,C,Cx,Cy and (if applicable) T                            #
C                                                                             #
C     The components (NORMx,NORMy) of the unit outward normal vector, and the #
C     initial triangle number KTRI, and the boundary arc number IARC may also #
C     be referenced.  You can also reference the normal derivative Cnorm.     #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + CURVED interior interface arcs are considered part of the boundary,  +#
C     + for the boundary integral computations, ONLY IF they have arc numbers+#
C     + in the range 8000-8999.  In this case, since an interface arc is     +#
C     + considered to be a boundary for both of the subregions it separates, +#
C     + the boundary integral will be computed twice on each curved          +#
C     + interface arc, once with (NORMx,NORMy) defined in each direction.    +#
C     +                                                                      +#
C     + If you only want to integrate a function over part of the boundary,  +#
C     + define that function to be zero on the rest of the boundary.  You    +#
C     + can examine the point (X,Y) to determine if it is on the desired     +#
C     + boundary segment, or the boundary arc number IARC, or the initial    +#
C     + triangle number KTRI (if INTRI=3),                                   +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C                                                  BND. INTEGRAL1 DEFINED      
      D = 5
      if (kint8z.eq.-1) yd8z =                                                 
     & 2*pi*y*D*Cnorm
C    & [DEFAULT SELECTED, DEFINITION COMMENTED OUT]                            
                          else                                                 
C##############################################################################
C     Now enter FORTRAN expressions to define the PDE coefficients, which     #
C     may be functions of                                                     #
C                                                                             #
C                             X,Y,C,Cx,Cy                                     #
C                                                                             #
C     They may also be functions of the initial triangle number KTRI          #
C     and, in some cases, of the parameter T.                                 #
C                                                                             #
C     Recall that the PDE has the form                                        #
C                                                                             #
C                    d/dX*A + d/dY*B = F                                      #
C                                                                             #
C##############################################################################
      if (x.le.0.0) then                                                       
         Q = 0                                                                 
         D = D1                                                                
      else                                                                     
         Q = 1                                                                 
         D = D2                                                                
      endif                                                                    
                if (j8z.eq.0) then                                             
      yd8z = 0.0                                                               
C                                                  F DEFINED                   
      if (i8z.eq.    1) yd8z =                                                 
     & -y*Q                                                                   
C                                                  A DEFINED                   
      if (i8z.eq.    2) yd8z =                                                 
     & y*D*Cx                                                                 
C                                                  B DEFINED                   
      if (i8z.eq.    3) yd8z =                                                 
     & y*D*Cy                                                                 
                else                                                           
                endif                                                          
                          endif                                                
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      function u8z(i8z,x,y,ktri,t0)                                            
      implicit double precision (a-h,o-z)                                      
      common/parm8z/ pi,D1    ,D2                                              
      u8z = 0.0                                                                
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      function fb8z(i8z,iarc8z,ktri,s,x,y,t)                                   
      implicit double precision (a-h,o-z)                                      
      common/parm8z/ pi,D1    ,D2                                              
      fb8z = 0.0                                                               
C        NO BOUNDARY CONDITIONS DEFINED ON NEGATIVE ARCS.                      
C        TO ADD BCs FOR NEGATIVE ARCS, USE BLOCK BELOW AS MODEL                
      IARC = 0                                                                 
                if (iarc8z.eq.iarc) then                                       
C##############################################################################
C     Enter a FORTRAN expression to define FB on this arc.  It may be a       #
C     function of X,Y and (if applicable) T.                                  #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + This function may also reference the initial triangle number KTRI,   +#
C     + and the arc parameter S (S = P or Q when INTRI=2).                   +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C                                                                             #
C     Recall that fixed boundary conditions have the form                     #
C                                                                             #
C                    C = FB                                                   #
C                                                                             #
C##############################################################################
C                                                  FB DEFINED                  
C     if (i8z.eq.    1) fb8z =                                                 
C    & [DEFAULT SELECTED, DEFINITION COMMENTED OUT]                            
                endif                                                          
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine gb8z(gd8z,i8z,j8z,iarc8z,ktri,s,x,y,t)                        
      implicit double precision (a-h,o-z)                                      
      parameter (neqnmx=  99)                                                  
C        un8z(1,I),un8z(2,I),un8z(3,I) hold the (rarely used) values           
C        of UI,UIx,UIy from the previous iteration or time step.               
C        (normx,normy) is the (rarely used) unit outward normal vector         
      common/dtdp4/un8z(3,neqnmx),uu8z(neqnmx,3)                               
      common/dtdp17/normx,normy,ibarc8z                                        
      common/dtdp49/bign8z                                                     
      double precision normx,normy                                             
      common/parm8z/ pi,D1    ,D2                                              
      zero(f8z) = bign8z*f8z                                                   
      C  = uu8z( 1,1)                                                          
      Cx = uu8z( 1,2)                                                          
      Cy = uu8z( 1,3)                                                          
      if (j8z.eq.0) gd8z = 0.0                                                 
C        NO BOUNDARY CONDITIONS DEFINED ON POSITIVE ARCS.                      
C        TO ADD BCs FOR POSITIVE ARCS, USE BLOCK BELOW AS MODEL                
      IARC = 0                                                                 
                if (iarc8z.eq.iarc) then                                       
C##############################################################################
C     Enter FORTRAN expressions to define the following free boundary         #
C     condition functions on this arc.  They may be functions of              #
C                                                                             #
C                X,Y,C,Cx,Cy and (if applicable) T                            #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + These functions may also reference the components (NORMx,NORMy) of   +#
C     + the unit outward normal vector, the initial triangle number KTRI,    +#
C     + and the arc parameter S (S = P or Q when INTRI=2).                   +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C                                                                             #
C     Recall that free boundary conditions have the form                      #
C                                                                             #
C                       A*nx+B*ny = GB                                        #
C                                                                             #
C##############################################################################
                          if (j8z.eq.0) then                                   
C                                                  GB DEFINED                  
C     if (i8z.eq.    1) gd8z =                                                 
C    & [DEFAULT SELECTED, DEFINITION COMMENTED OUT]                            
                          else                                                 
                          endif                                                
                endif                                                          
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine pmod8z(x,y,ktri,t,a,b)                                        
      implicit double precision (a-h,o-z)                                      
      parameter (neqnmx=  99)                                                  
      common/dtdp4/un8z(3,neqnmx),uu8z(3,neqnmx)                               
      common/dtdp6/upr8z(3,neqnmx),uab8z(3,neqnmx)                             
      common/dtdp9/uprint(neqnmx),aprint(neqnmx),bprint(neqnmx)                
      common/dtdp14/sint(20),bint(20),slim8z(20),blim8z(20)                    
      common/parm8z/ pi,D1    ,D2                                              
      C  = uu8z(1, 1)                                                          
      Cx = uu8z(2, 1)                                                          
      Cy = uu8z(3, 1)                                                          
      a1 = upr8z(2, 1)                                                         
      b1 = upr8z(3, 1)                                                         
C##############################################################################
C     If you don't want to read the FINE PRINT, default all of the following  #
C     variables.                                                              #
C                                                                             #
C     +++++++++++++++ THE "FINE PRINT" (CAN USUALLY BE IGNORED) ++++++++++++++#
C     + Normally, PDE2D saves the values of C,A,B at the output points.      +#
C     + If different variables are to be saved (for later printing or        +#
C     + plotting) the following functions can be used to re-define the       +#
C     + output variables:                                                    +#
C     +    define UPRINT(1) to replace C                                     +#
C     +           APRINT(1)            A                                     +#
C     +           BPRINT(1)            B                                     +#
C     + Each function may be a function of                                   +#
C     +                                                                      +#
C     +           X,Y,C,Cx,Cy,A,B and (if applicable) T                      +#
C     +                                                                      +#
C     + Each may also be a function of the initial triangle number KTRI and  +#
C     + the integral estimates SINT(1),...,BINT(1),...                       +#
C     +                                                                      +#
C     + The default for each variable is no change, for example, UPRINT(1)   +#
C     + defaults to C.  Enter FORTRAN expressions for each of the            +#
C     + following functions (or default).                                    +#
C     ++++++++++++++++++++++++++ END OF "FINE PRINT" +++++++++++++++++++++++++#
C##############################################################################
C        DEFINE UPRINT(*),APRINT(*),BPRINT(*) HERE:
      return                                                                   
      end                                                                      
C        dummy routines                                                        
      function axis8z(i8z,x,y,z,ical8z)                                        
      implicit double precision (a-h,o-z)                                      
      axis8z = 0                                                               
      return                                                                   
      end                                                                      
                                                                               
                                                                               
      subroutine postpr(tout,nsave,xout,yout,inrg,nx,ny,uout,neqn)             
      implicit double precision (a-h,o-z)                                      
      dimension xout(0:nx,0:ny),yout(0:nx,0:ny),tout(0:nsave)                  
      dimension inrg(0:nx,0:ny),uout(0:nx,0:ny,3,neqn,0:nsave)                 
      common/parm8z/ pi,D1    ,D2                                              
      common /dtdp27/ itask,npes,icomm                                         
      common /dtdp46/ eps8z,cgtl8z,npmx8z,itype                                
      data lun,lud/0,47/                                                       
      if (itask.gt.0) return                                                   
C     UOUT(I,J,IDER,IEQ,L) = U-sub-IEQ, if IDER=1                              
C                            A-sub-IEQ, if IDER=2                              
C                            B-sub-IEQ, if IDER=3                              
C       (possibly as modified by UPRINT,..)                                    
C       at the point (XOUT(I,J) , YOUT(I,J))                                   
C       at time/iteration TOUT(L).                                             
C     INRG(I,J) = 1 if this point is in R                                      
C               = 0 otherwise                                                  
C       ******* ADD POSTPROCESSING CODE HERE:                                  
C       IN THE EXAMPLE BELOW, MATLAB PLOTFILES pde2d.m,                        
C      pde2d.rdm CREATED (REMOVE  COMMENTS TO ACTIVATE)                      
      if (lun.eq.0) then                                                     
         lun = 46                                                            
         open (lun,file='pde2d.m')                                           
         open (lud,file='pde2d.rdm')                                         
      endif                                                                  
      do 78753 l=0,nsave                                                     
         if (tout(l).ne.dtdplx(2)) nsave0 = l                                
78753 continue                                                               
      write (lud,78754) nsave0                                               
      write (lud,78754) neqn                                                 
      write (lud,78754) nx                                                   
      write (lud,78754) ny                                                   
78754 format (i8)                                                            
      do 78756 i=0,nx                                                        
      do 78755 j=0,ny                                                        
         write (lud,78762) xout(i,j),yout(i,j)                               
78755 continue                                                               
78756 continue                                                               
      do 78761 l=0,nsave0                                                    
         write (lud,78762) tout(l)                                           
         do 78760 ieq=1,neqn                                                 
         do 78759 ider=1,3                                                   
         do 78758 i=0,nx                                                     
         do 78757 j=0,ny                                                     
            if (inrg(i,j).eq.1) then                                         
               write (lud,78762) uout(i,j,ider,ieq,l)                        
            else                                                             
               write (lud,78763)                                             
            endif                                                            
78757    continue                                                            
78758    continue                                                            
78759    continue                                                            
78760    continue                                                            
78761 continue                                                               
78762 format (e16.8)                                                         
78763 format ('NaN')                                                         
      write (lun,*) '% Read solution from pde2d.rdm'                         
      write (lun,*) 'fid = fopen(''pde2d.rdm'');'                            
      write (lun,*) 'NSAVE = fscanf(fid,''%g'',1);'                          
      write (lun,*) 'NEQN = fscanf(fid,''%g'',1);'                           
      write (lun,*) 'NX = fscanf(fid,''%g'',1);'                             
      write (lun,*) 'NY = fscanf(fid,''%g'',1);'                             
      if (itype.eq.2) then                                                   
         write (lun,*) 'L0 = 0;'                                             
      else                                                                   
         write (lun,*) 'L0 = 1;'                                             
      endif                                                                  
      write (lun,*) 'T = zeros(NSAVE+1,1);'                                  
      write (lun,*) 'X = zeros(NY+1,NX+1);'                                  
      write (lun,*) 'Y = zeros(NY+1,NX+1);'                                  
      write (lun,*) 'U = zeros(NY+1,NX+1,NSAVE+1,3,NEQN);'                   
      write (lun,*) 'for i=0:NX'                                             
      write (lun,*) 'for j=0:NY'                                             
      write (lun,*) '   X(j+1,i+1) = fscanf(fid,''%g'',1);'                  
      write (lun,*) '   Y(j+1,i+1) = fscanf(fid,''%g'',1);'                  
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'for l=0:NSAVE'                                          
      write (lun,*) 'T(l+1) = fscanf(fid,''%g'',1);'                         
      write (lun,*) 'for ieq=1:NEQN'                                         
      write (lun,*) 'for ider=1:3'                                           
      write (lun,*) 'for i=0:NX'                                             
      write (lun,*) 'for j=0:NY'                                             
      write (lun,*)                                                          
     & '   U(j+1,i+1,l+1,ider,ieq) = fscanf(fid,''%g'',1);'                  
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'xmin = min(min(X(:,:)));'                               
      write (lun,*) 'xmax = max(max(X(:,:)));'                               
      write (lun,*) 'ymin = min(min(Y(:,:)));'                               
      write (lun,*) 'ymax = max(max(Y(:,:)));'                               
      write (lun,*) 'hx = 0.1*(xmax-xmin);'                                  
      write (lun,*) 'hy = 0.1*(ymax-ymin);'                                  
      write (lun,*) '% Surface plots of each variable'                       
      write (lun,*) 'for IEQ=1:NEQN'                                         
      write (lun,*) 'IDER = 1;'                                              
      write (lun,*)                                                          
     & 'umin = min(min(min(U(:,:,L0+1:NSAVE+1,IDER,IEQ))));'                 
      write (lun,*)                                                          
     & 'umax = max(max(max(U(:,:,L0+1:NSAVE+1,IDER,IEQ))));'                 
      write (lun,*) 'for L=L0:NSAVE'                                         
      write (lun,*) '   figure'                                              
      write (lun,*) '   surf(X,Y,U(:,:,L+1,IDER,IEQ))'                       
      write (lun,*) '   axis([xmin xmax ymin ymax umin umax])'               
      write (lun,*) '   xlabel(''X'')'                                       
      write (lun,*) '   ylabel(''Y'')'                                       
      write (lun,*) '   zlabel([''U'',num2str(IEQ)])'                        
      write (lun,*) '   title(['' T = '',num2str(T(L+1))])'                  
      write (lun,*) '   view(-37.5,30.0)'                                    
      write (lun,*) 'end'                                                    
      write (lun,*) 'end'                                                    
      write (lun,*) '% ******* Choose variables for vector plots'            
      write (lun,*) '% (see comments in POSTPR)'                             
      write (lun,*) 'IEQ1 = 1;'                                              
      write (lun,*) 'IDER1 = 2;'                                             
      write (lun,*) 'IEQ2 = 1;'                                              
      write (lun,*) 'IDER2 = 3;'                                             
      write (lun,*) 'for L=L0:NSAVE'                                         
      write (lun,*) '   figure'                                              
      write (lun,*) '   quiver(X,Y,U(:,:,L+1,IDER1,IEQ1), ...'               
      write (lun,*) '              U(:,:,L+1,IDER2,IEQ2))'                   
      write (lun,*) '   axis([xmin-hx xmax+hx ymin-hy ymax+hy])'             
      write (lun,*) '   xlabel(''X'')'                                       
      write (lun,*) '   ylabel(''Y'')'                                       
      write (lun,*) '   title(['' T = '',num2str(T(L+1))])'                  
      write (lun,*) 'end'                                                    
      return                                                                   
      end                                                                      
